﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Guardias : MonoBehaviour 
{
	RaycastHit hit;

	public float detectRange = 2.0f;
	public float rotationSpeed = 0.5f;
	public float guardAngle = 20.0f;

	Vector3 puntoA;
	Vector3 puntoB;

	public bool showGizmo = false;

	void Start () 
	{
		puntoA = transform.eulerAngles + new Vector3(0f, 0, guardAngle);
    	puntoB = transform.eulerAngles + new Vector3(0f, 0, -guardAngle);
	}
	
	// Update is called once per frame
	void Update ()
	{
		Vigilar();
	}

	void Vigilar()
	{

    	float time = Mathf.PingPong(Time.time * rotationSpeed, 1);
    	transform.eulerAngles = Vector3.Lerp(puntoA, puntoB, time);

		if(Physics.SphereCast(transform.position, detectRange, transform.TransformDirection(-Vector3.up), out hit, Mathf.Infinity))
        {
        	if(hit.transform.gameObject.tag =="Perro")
        	{

    			GameObject perro = hit.transform.gameObject;
        		transform.GetChild(0).GetComponent<Light>().color = Color.red;
        		hit.transform.GetComponent<Movimiento>().Respawn();
        		//TODO perder
        	}else
        	{
        		transform.GetChild(0).GetComponent<Light>().color = Color.yellow;
        	}
        }

	}

	void OnDrawGizmos()
	{	
		if(showGizmo)
		{
		    Gizmos.color = Color.red;
       		Gizmos.DrawSphere(hit.point, detectRange);
		}
	}

}
